<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\Libs\Util\DateUtil;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DTO;

class ped02100modalidadePagamentoController extends TeknisaCrud {

    protected $dataSourceName = '';
    protected $dataSourceNameToSave = '';
    protected $parameterBag;
    protected $newCode;
    protected $environment;
    protected $entityManager;

    public function __construct($crudService, ParameterBag $parameterBag, $newCode, $environment, $entityManager) {
        parent::__construct($crudService, $parameterBag);
        $this->parameterBag = $parameterBag;
        $this->newCode = $newCode;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
       
    }
   
    public function saveModalidade($request,$response) {
    
        try {
            
            $this->entityManager->beginTransaction();
            
            $modalidade = $request->getDataSet()->getRows()[0];
            
            $prazos = $request->getDataSet()->getRows()[1];
            
            $dataSet = new DataSet("data", [$modalidade[0]]);
            
            $requestSalvarMod = new DTO\Request\DataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
            $this->dataSourceName = 'modpgto_formpgto_tiporece';
            
            $this->dataSourceNameToSave = 'modpgto_formpgto_tiporece';
                
            parent::save($requestSalvarMod,$response);
            foreach($prazos as $prazo) {
                
                $dataSet = new DataSet ("prazomodpgto", array($prazo));
                
                $requestSalvarModPrazo = new DTO\Request\dataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
                $this->dataSourceName = 'prazomodpgto';
                
                $this->dataSourceNameToSave = 'prazomodpgto';
            
                parent::save($requestSalvarModPrazo,$response);
                
            }
        
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
        
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            
            $this->entityManager->rollback();
            
        }
        
    }
    
    public function deletaPrazoModalidade($request,$response) {
        try {
            
            $this->dataSourceName = 'prazomodpgto';
            parent::delete($request, $response);
            
        } catch (\Exception $e) {
            $response->setError(new Error("Error in delete data. ". $e->getMessage(), 500));
        }
    }
    
    public function deletaModalidade($request,$response) {
        
        try {
            
            $this->entityManager->beginTransaction();
             
            $modalidade = $request->getDataSet()->getRows()[0];
            
            $prazos = $request->getDataSet()->getRows()[1];
            
            $dataSet = new DataSet("modpgto", [$modalidade[0]]);
            
            $requestDeleteMod = new DTO\Request\DataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            
            
            
            foreach($prazos as $prazo) {
                
                $dataSetPrazos = new DataSet ("prazomodpgto", array($prazo));
                
                $requestDeleteModPrazo = new DTO\Request\dataSet($dataSetPrazos, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            
                $this->deletaPrazoModalidade($requestDeleteModPrazo,$response);
                
            }
            
            $this->dataSourceName = 'modpgto';
            parent::delete($requestDeleteMod,$response);

            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            
            
        
            $response->setError(new Error("Error in delete data. ". $e->getMessage(), 500));
            
            $this->entityManager->rollback();
            
        }
        
        
    }

}
    